#ifndef EFL_GENERATED_EVAS_3D_MATERIAL_HH
#define EFL_GENERATED_EVAS_3D_MATERIAL_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_3d_material.eo.h"
}

#include "evas_3d_object.eo.hh"
#include "evas_common_interface.eo.hh"

struct evas_3d_material
      : evas_3d_object,
      efl::eo::detail::extension_inheritance<evas::common_interface>::template type< ::evas_3d_material>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_3d_material(Eo* eo)
      : evas_3d_object(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit evas_3d_material(std::nullptr_t)
      : evas_3d_object(nullptr)
   {}

   /// @brief Call the object's constructor.
   /// Should not be used with #eo_do. Only use it with #eo_do_super.
   ///
   evas_3d_material(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : evas_3d_material(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   evas_3d_material(evas_3d_material const& other)
      : evas_3d_object(eo_ref(other._eo_ptr()))
   {}

   ~evas_3d_material() {}

   /// @brief Pure virtual update_notify function..
   /// Update request for the object.
   ///
   void update_notify() const
   {
      eo_do(_eo_ptr(), ::evas_3d_object_update_notify());
   }

   /// @brief Pure virtual change_notify function..
   /// Update request for the object.
   ///
   /// @param state State that is changed
   /// @param ref The Object that caused the change
   ///
   void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_object_change_notify(state_, ref_));
   }

   /// @param enable Whether to enable the attribute (@c EINA_TRUE), or not (@c EINA_FALSE).
   ///
   bool enable_get(Evas_3D_Material_Attrib attrib_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_material_enable_get(attrib_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param enable Whether to enable the attribute (@c EINA_TRUE), or not (@c EINA_FALSE).
   ///
   void enable_set(Evas_3D_Material_Attrib attrib_, bool enable_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_material_enable_set(attrib_, efl::eolian::to_c(enable_)));
   }

   /// @param shininess Shininess value.
   ///
   Evas_Real shininess_get() const
   {
      Evas_Real _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_material_shininess_get());
      return _tmp_ret;
   }

   /// @param shininess Shininess value.
   ///
   void shininess_set(Evas_Real shininess_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_material_shininess_set(shininess_));
   }

   /// @param texture 
   ///
   Evas_3D_Texture * texture_get(Evas_3D_Material_Attrib attrib_) const
   {
      Evas_3D_Texture * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_3d_material_texture_get(attrib_));
      return _tmp_ret;
   }

   /// @brief Set the texture of the given material.
   ///
   /// You have to enable the desired attribute first.
   ///
   /// @see evas_3d_material_enable_set()
   ///
   /// @ingroup Evas_3D_Material
   ///
   /// @param texture 
   ///
   void texture_set(Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_material_texture_set(attrib_, texture_));
   }

   /// @param attrib Material attribute ID.
   /// @param r Red component of the color.
   /// @param g Green component of the color.
   /// @param b Blue component of the color.
   /// @param a Alpha component of the color.
   ///
   void color_set(Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_material_color_set(attrib_, r_, g_, b_, a_));
   }

   /// @param attrib Material attribute ID.
   /// @param[out] r Pointer to receive red component of the color.
   /// @param[out] g Pointer to receive green component of the color.
   /// @param[out] b Pointer to receive blue component of the color.
   /// @param[out] a Pointer to receive alpha component of the color.
   ///
   void color_get(Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
   {
      eo_do(_eo_ptr(), ::evas_3d_material_color_get(attrib_, r_, g_, b_, a_));
   }

   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_MATERIAL_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_ref(EVAS_3D_MATERIAL_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _evas_3d_material_update_notify_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->update_notify();
}

template <typename T>
void _evas_3d_material_change_notify_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_State state_, Evas_3D_Object * ref_)
{
   static_cast<T*>(self->this_)->change_notify(state_, ref_);
}

template <typename T>
bool _evas_3d_material_enable_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_)
{
   return static_cast<T*>(self->this_)->enable_get(attrib_);
}

template <typename T>
void _evas_3d_material_enable_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_, Eina_Bool enable_)
{
   static_cast<T*>(self->this_)->enable_set(attrib_, efl::eolian::to_cxx<bool>(enable_, std::tuple<std::false_type>()));
}

template <typename T>
Evas_Real _evas_3d_material_shininess_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->shininess_get();
}

template <typename T>
void _evas_3d_material_shininess_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Real shininess_)
{
   static_cast<T*>(self->this_)->shininess_set(shininess_);
}

template <typename T>
Evas_3D_Texture * _evas_3d_material_texture_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_)
{
   return static_cast<T*>(self->this_)->texture_get(attrib_);
}

template <typename T>
void _evas_3d_material_texture_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_)
{
   static_cast<T*>(self->this_)->texture_set(attrib_, texture_);
}

template <typename T>
void _evas_3d_material_color_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
{
   static_cast<T*>(self->this_)->color_set(attrib_, r_, g_, b_, a_);
}

template <typename T>
void _evas_3d_material_color_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
{
   static_cast<T*>(self->this_)->color_get(attrib_, r_, g_, b_, a_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_material >
{
   template <typename T>
   struct type
   {
      virtual void update_notify()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_update_notify());
      }

      virtual void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_object_change_notify(state_, ref_));
      }

      virtual bool enable_get(Evas_3D_Material_Attrib attrib_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_material_enable_get(attrib_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void enable_set(Evas_3D_Material_Attrib attrib_, bool enable_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_material_enable_set(attrib_, efl::eolian::to_c(enable_)));
      }

      virtual Evas_Real shininess_get()
      {
         Evas_Real _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_material_shininess_get());
            return _tmp_ret;
      }

      virtual void shininess_set(Evas_Real shininess_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_material_shininess_set(shininess_));
      }

      virtual Evas_3D_Texture * texture_get(Evas_3D_Material_Attrib attrib_)
      {
         Evas_3D_Texture * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_material_texture_get(attrib_));
            return _tmp_ret;
      }

      virtual void texture_set(Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_material_texture_set(attrib_, texture_));
      }

      virtual void color_set(Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_material_color_set(attrib_, r_, g_, b_, a_));
      }

      virtual void color_get(Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_3d_material_color_get(attrib_, r_, g_, b_, a_));
      }

   };
};


template<>
struct operation_description_class_size< ::evas_3d_material >
{
   static const int value = 10;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::evas_3d_material>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_material_update_notify_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_3d_object_update_notify);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_material_change_notify_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_object_change_notify);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_material_enable_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_material_enable_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_material_enable_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_material_enable_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_material_shininess_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_material_shininess_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_material_shininess_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_material_shininess_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_evas_3d_material_texture_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_3d_material_texture_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_evas_3d_material_texture_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_3d_material_texture_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_evas_3d_material_color_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::evas_3d_material_color_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_evas_3d_material_color_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::evas_3d_material_color_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::evas_3d_material >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_3d_material, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::evas_3d_material >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_3d_material, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::evas_3d_material>
{
   template <typename U>
   struct type
   {
      operator ::evas_3d_material() const
      {
         return ::evas_3d_material(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void update_notify()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_object_update_notify());
      }

      void change_notify(Evas_3D_State state_, Evas_3D_Object * ref_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_object_change_notify(state_, ref_));
      }

      bool enable_get(Evas_3D_Material_Attrib attrib_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_material_enable_get(attrib_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void enable_set(Evas_3D_Material_Attrib attrib_, bool enable_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_material_enable_set(attrib_, efl::eolian::to_c(enable_)));
      }

      Evas_Real shininess_get()
      {
         Evas_Real _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_material_shininess_get());
            return _tmp_ret;
      }

      void shininess_set(Evas_Real shininess_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_material_shininess_set(shininess_));
      }

      Evas_3D_Texture * texture_get(Evas_3D_Material_Attrib attrib_)
      {
         Evas_3D_Texture * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_3d_material_texture_get(attrib_));
            return _tmp_ret;
      }

      void texture_set(Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_material_texture_set(attrib_, texture_));
      }

      void color_set(Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_material_color_set(attrib_, r_, g_, b_, a_));
      }

      void color_get(Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_3d_material_color_get(attrib_, r_, g_, b_, a_));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::evas_3d_material>)
{
   return (EVAS_3D_MATERIAL_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_3D_MATERIAL_HH

